// Autogenerated from Pigeon (v0.1.9), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

@class InitializeRequest;
@class SetDepartmentRequest;
@class StartChatRequest;
@class SetVisitorInfoRequest;
@class VisitorTagsRequest;
@class VisitorNoteRequest;

@interface InitializeRequest : NSObject
@property(nonatomic, copy, nullable) NSString * accountKey;
@property(nonatomic, copy, nullable) NSString * appId;
@end

@interface SetDepartmentRequest : NSObject
@property(nonatomic, copy, nullable) NSString * department;
@end

@interface StartChatRequest : NSObject
@property(nonatomic, strong, nullable) NSNumber * isPreChatFormEnabled;
@property(nonatomic, strong, nullable) NSNumber * isOfflineFormEnabled;
@property(nonatomic, strong, nullable) NSNumber * isAgentAvailabilityEnabled;
@property(nonatomic, strong, nullable) NSNumber * isChatTranscriptPromptEnabled;
@property(nonatomic, copy, nullable) NSString * messagingName;
@property(nonatomic, copy, nullable) NSString * iosBackButtonTitle;
@property(nonatomic, strong, nullable) NSNumber * iosNavigationBarColor;
@property(nonatomic, strong, nullable) NSNumber * iosNavigationTitleColor;
@end

@interface SetVisitorInfoRequest : NSObject
@property(nonatomic, copy, nullable) NSString * name;
@property(nonatomic, copy, nullable) NSString * email;
@property(nonatomic, copy, nullable) NSString * phoneNumber;
@end

@interface VisitorTagsRequest : NSObject
@property(nonatomic, strong, nullable) NSArray * tags;
@end

@interface VisitorNoteRequest : NSObject
@property(nonatomic, copy, nullable) NSString * note;
@end

@protocol ChatApi
-(void)initialize:(InitializeRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)setDepartment:(SetDepartmentRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)startChat:(StartChatRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void ChatApiSetup(id<FlutterBinaryMessenger> binaryMessenger, id<ChatApi> _Nullable api);

@protocol ProfileApi
-(void)setVisitorInfo:(SetVisitorInfoRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)addVisitorTags:(VisitorTagsRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)removeVisitorTags:(VisitorTagsRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)setVisitorNote:(VisitorNoteRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)appendVisitorNote:(VisitorNoteRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(void)clearVisitorNotes:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void ProfileApiSetup(id<FlutterBinaryMessenger> binaryMessenger, id<ProfileApi> _Nullable api);

NS_ASSUME_NONNULL_END
